apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ elasticsearch_name }}
  name: {{ elasticsearch_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ (elasticsearch_master_replicas | default(elasticsearch_replicas)) if (elasticsearch_is_master | default(False)) else (elasticsearch_data_replicas | default(elasticsearch_replicas)) }}
  selector:
    matchLabels:
      name: {{ elasticsearch_name }}
  serviceName: {{ elasticsearch_name }}
  template:
    metadata:
      labels:
        cluster: {{ elasticsearch_cluster_name | default(elasticsearch_name) }}
        name: {{ elasticsearch_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
{% if k8s_flavor == 'openshift' and (ocp_major | int) > 3 %}
        tuned.openshift.io/elasticsearch: ""
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ elasticsearch_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: cluster
                  operator: In
                  values: [ {{ elasticsearch_cluster_name | default(elasticsearch_name) }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 21
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ elasticsearch_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: cluster
                  operator: In
                  values: [ {{ elasticsearch_cluster_name | default(elasticsearch_name) }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 21
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: ELASTICSEARCH_CLUSTER_NAME
          value: {{ elasticsearch_cluster_name | default(elasticsearch_name) }}
        - name: ELASTICSEARCH_HAS_MASTERS
          value: "{{ elasticsearch_master_replicas | default(elasticsearch_replicas) | int }}"
{% if elasticsearch_is_master | default(False) %}
        - name: ELASTICSEARCH_IS_DATA
          value: "false"
        - name: ELASTICSEARCH_IS_INGEST
          value: "false"
        - name: ELASTICSEARCH_IS_MASTER
          value: "true"
        - name: ELASTICSEARCH_JVM_XMS
          value: {{ elasticsearch_master_jvm_xms | default(jvm_xms | default('512m')) }}
        - name: ELASTICSEARCH_JVM_XMX
          value: {{ elasticsearch_master_jvm_xmx | default(jvm_xmx | default('512m')) }}
{% elif elasticsearch_is_data | default(False) %}
        - name: ELASTICSEARCH_IS_DATA
          value: "true"
        - name: ELASTICSEARCH_IS_INGEST
          value: "true"
        - name: ELASTICSEARCH_IS_MASTER
          value: "false"
        - name: ELASTICSEARCH_JVM_XMS
          value: {{ elasticsearch_data_jvm_xms | default(jvm_xms | default('512m')) }}
        - name: ELASTICSEARCH_JVM_XMX
          value: {{ elasticsearch_data_jvm_xmx | default(jvm_xmx | default('512m')) }}
        - name: ELASTICSEARCH_MASTER_SVC
          value: {{ elasticsearch_cluster_name }}
{% else %}
        - name: ELASTICSEARCH_IS_DATA
          value: "true"
        - name: ELASTICSEARCH_IS_INGEST
          value: "true"
        - name: ELASTICSEARCH_IS_MASTER
          value: "true"
        - name: ELASTICSEARCH_JVM_XMS
          value: {{ elasticsearch_data_jvm_xms | default(jvm_xms | default('512m')) }}
        - name: ELASTICSEARCH_JVM_XMX
          value: {{ elasticsearch_data_jvm_xmx | default(jvm_xmx | default('512m')) }}
{% endif %}
        - name: ELASTICSEARCH_PLUGINS
          value: "{{ (elasticsearch_plugins | default([])) | join(' ') }}"
        - name: HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: POD_IP
          valueFrom:
            fieldRef:
              fieldPath: status.podIP
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='elasticsearch'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9200
          timeoutSeconds: 5
        name: elasticsearch
        ports:
        - name: esearch
          containerPort: 9200
        - name: nodes
          containerPort: 9300
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - "-i"
            - "-c"
            - /is-ready.sh
          initialDelaySeconds: 40
          periodSeconds: 10
          timeoutSeconds: 5
        resources:
          limits:
{% if elasticsearch_is_master | default(False) %}
            cpu: "{{ elasticsearch_master_cpu_limit | default(cpu_limit) }}"
            memory: "{{ elasticsearch_master_memory_limit | default(memory_limit) }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ elasticsearch_master_cpu_limit | default(cpu_limit) }}"
            memory: "{{ elasticsearch_master_memory_limit | default(memory_limit) }}"
{% else %}
            cpu: "{{ elasticsearch_master_cpu_request | default(cpu_request) }}"
            memory: "{{ elasticsearch_master_memory_request | default(memory_request) }}"
{% endif %}
{% else %}
            cpu: "{{ elasticsearch_data_cpu_limit | default(cpu_limit) }}"
            memory: "{{ elasticsearch_data_memory_limit | default(memory_limit) }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ elasticsearch_data_cpu_limit | default(cpu_limit) }}"
            memory: "{{ elasticsearch_data_memory_limit | default(memory_limit) }}"
{% else %}
            cpu: "{{ elasticsearch_data_cpu_request | default(cpu_request) }}"
            memory: "{{ elasticsearch_data_memory_request | default(memory_request) }}"
{% endif %}
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9200
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/elasticsearch
          name: data
{% if do_exporters %}
      - args:
        - --es.all
        - --es.cluster_settings
        - --es.indices
        - --es.shards
        - --es.snapshots
        - --es.uri=http://127.0.0.1:9200
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        image: {{ (opsimages | json_query("[?name=='esearchexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      terminationGracePeriodSeconds: {{ elasticsearch_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ elasticsearch_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
      - labelSelector:
          matchLabels:
            cluster: {{ elasticsearch_cluster_name | default(elasticsearch_name) }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
{% if elasticsearch_is_master | default(True) %}
          storage: "{{ elasticsearch_master_volume_capacity | default(elasticsearch_data_volume_capacity) }}"
{% else %}
          storage: "{{ elasticsearch_data_volume_capacity }}"
{% endif %}
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
